local VEHICLE_MAX_OVERLAY = 4;
local VEHICLE_MAX_ARTWORK = 10;
local VEHICLE_MAX_BORDER = 7;
local VEHICLE_MAX_BACKGROUND = 3;
local vehiclescale = 0.75;
local Semiclass = UnitClass("player");
local Semilevel = UnitLevel("player");
local SemiMaxLevel = MAX_PLAYER_LEVEL;
local SemiMicroMoved;

local SemiMicroMenuButtons = {			--12 Buttons
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	PVPMicroButton,
	LFDMicroButton,
	CompanionsMicroButton,
	EJMicroButton,
	MainMenuMicroButton,
	StoreMicroButton
	--HelpMicroButton
}

function Semi_LinkMainMenuBarToDragButton()
	MainMenuBar:ClearAllPoints();
	MainMenuBar:SetPoint("BOTTOM", SemiMainMenuBarDragButton, "BOTTOM");

	if (not SF_MainMenuBarTexture_State) then
		MainMenuBarTexture0:Hide();
		MainMenuBarTexture1:Hide();
		if Semilevel == SemiMaxLevel then
			MainMenuMaxLevelBar0:Hide();
			MainMenuMaxLevelBar1:Hide();
		end
	end

	if (SF_MainMenuBarTexture_State) then
		MainMenuBarTexture0:Show();
		MainMenuBarTexture1:Show();
		if Semilevel == SemiMaxLevel then
			MainMenuMaxLevelBar0:Show();
			MainMenuMaxLevelBar1:Show();
		end
	end

	if (not SF_ActionPageButtons_State) then
		ActionBarUpButton:Hide();
		ActionBarDownButton:Hide();
	end

	if (SF_ActionPageButtons_State) then
		ActionBarUpButton:Show();
		ActionBarDownButton:Show();
	end
-- Hiding various textures

MainMenuBarTexture2:Hide();
MainMenuBarTexture3:Hide();
MainMenuMaxLevelBar2:Hide();
MainMenuMaxLevelBar3:Hide();
ReputationWatchBarTexture2:SetTexture("");
ReputationWatchBarTexture3:SetTexture("");
ReputationXPBarTexture2:SetTexture("");
ReputationXPBarTexture3:SetTexture("");
SlidingActionBarTexture0:Hide();
SlidingActionBarTexture1:Hide();
StanceBarLeft:SetAlpha(0);
StanceBarMiddle:SetAlpha(0);
StanceBarRight:SetAlpha(0);


--Moving the visible textures of the MainMenuBar to their right location
	
	MainMenuBar:SetWidth(512);
	MainMenuExpBar:SetWidth(500);
	ReputationWatchBar:SetWidth(500);
	MainMenuBarMaxLevelBar:SetWidth(500);
	ReputationWatchStatusBar:SetWidth(500);
	MainMenuMaxLevelBar0:ClearAllPoints();
	MainMenuMaxLevelBar1:ClearAllPoints();
	MainMenuMaxLevelBar0:SetPoint("BOTTOM", "MainMenuBarMaxLevelBar", "TOP", -125, 0);
	MainMenuMaxLevelBar1:SetPoint("BOTTOM", "MainMenuBarMaxLevelBar", "TOP", 125, 0);
	MainMenuBarTexture0:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", -125, 0);
	MainMenuBarTexture1:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", 125, 0);
	MainMenuBarLeftEndCap:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", -290, 0);
	MainMenuBarRightEndCap:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", 290, 0);

	
	if (Semilevel < SemiMaxLevel) then
		for i=10,19 do
			local semitexturehide = _G["MainMenuXPBarDiv"..i];
			if semitexturehide then
				semitexturehide:Hide();
			end
		end

	end
end

-- Vehicle Action Bar 
function Semi_LinkOverrideActionBarToDragButton()
	OverrideActionBar:ClearAllPoints();
	OverrideActionBar:SetPoint("BOTTOM", SemiOverrideActionBarDragButton, "BOTTOM");
end

-- Bottom left actionbar
function Semi_LinkBottomLeftBarToDragButton()
	if (not InCombatLockdown()) then
		UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomLeft"] = nil;
		MultiBarBottomLeft:ClearAllPoints();
		MultiBarBottomLeft:SetPoint("BOTTOM", SemiBottomLeftBarDragButton, "BOTTOM");
		if Semi_AB_BL_State then
			Semi_BottomLeft_Bar:Show();
			Semi_BottomLeft_Bar:EnableMouse("true");
			MultiBarBottomLeft:Hide();
		end
		Semi_BottomLeft_Bar:ClearAllPoints();
		Semi_BottomLeft_Bar:SetPoint("BOTTOM", SemiBottomLeftBarDragButton, "BOTTOM");
	end
end

-- Bottom right actionbar
function Semi_LinkBottomRightBarToDragButton()
	if (not InCombatLockdown()) then
		UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomRight"] = nil;
		MultiBarBottomRight:ClearAllPoints();
		MultiBarBottomRight:SetPoint("BOTTOM", SemiBottomRightBarDragButton, "BOTTOM");
		if Semi_AB_BR_State then
			Semi_BottomRight_Bar:Show();
			Semi_BottomRight_Bar:EnableMouse("true");
			MultiBarBottomRight:Hide();
		end
		Semi_BottomRight_Bar:ClearAllPoints();
		Semi_BottomRight_Bar:SetPoint("BOTTOM", SemiBottomRightBarDragButton, "BOTTOM");
	end
end

-- Move the micro menu buttons
function Semi_LinkMicroMenuToDragButton()
	if (not InCombatLockdown()) then
		if (CharacterMicroButton:GetParent():GetName() == "MainMenuBarArtFrame") then
			CharacterMicroButton:ClearAllPoints();
			CharacterMicroButton:SetPoint("BOTTOMLEFT", SemiMicroMenuDragButton, "BOTTOMLEFT");
			SemiMicroMoved = false; -- This is reset back to false, since micro menu is back where it belongs and we are out of combat
		elseif (CharacterMicroButton:GetParent():GetName() == "OverrideActionBar") or (CharacterMicroButton:GetParent():GetName() == "PetBattleFrame") then
			for i=1,12 do 
				SemiMicroMenuButtons[i]:SetScale(1);
			end
		end
	elseif (InCombatLockdown()) then --and (CharacterMicroButton:GetParent():GetName() ~= "MainMenuBarArtFrame") then
			SemiMicroMoved = true;  -- this means the hook moved the micromenu while in combat
									-- we need to tell my mod to call this function after combat to re-anchor it properly, in Semi_UpdateBarPositions()
	end   --MoveMicroButtons can fire and not move it away from main menu bar, this can happen with full screen map opening and closing.
		--micro buttons simple stay where they are, whether it is main menu bar or override bar or petbattleframe
end
hooksecurefunc("MoveMicroButtons", Semi_LinkMicroMenuToDragButton);
--- this is called everytime by mainmenubar via it's "OnShow" tag, so this can be called after the exit of full screen map while in combat


-- Move the bags
function Semi_LinkInventoryBagsToDragButton()
		MainMenuBarBackpackButton:ClearAllPoints();
		MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", SemiInventoryBagsDragButton, "BOTTOMRIGHT");
end

function ShowSemiBags()
	MainMenuBarBackpackButton:Show();
	CharacterBag0Slot:Show();
	CharacterBag1Slot:Show();
	CharacterBag2Slot:Show();
	CharacterBag3Slot:Show();
	Semi_LinkInventoryBagsToDragButton();
end

function HideSemiBags()
	MainMenuBarBackpackButton:Hide();
	CharacterBag0Slot:Hide();
	CharacterBag1Slot:Hide();
	CharacterBag2Slot:Hide();
	CharacterBag3Slot:Hide();
end

function ShowSemiMenu()
	CharacterMicroButton:SetAlpha(1);
	SpellbookMicroButton:SetAlpha(1);
	TalentMicroButton:SetAlpha(1);
	AchievementMicroButton:SetAlpha(1);
	QuestLogMicroButton:SetAlpha(1);
	GuildMicroButton:SetAlpha(1);
	PVPMicroButton:SetAlpha(1);
	LFDMicroButton:SetAlpha(1);
	CompanionsMicroButton:SetAlpha(1);
	EJMicroButton:SetAlpha(1);
	MainMenuMicroButton:SetAlpha(1);
	HelpMicroButton:SetAlpha(1);
	
	CharacterMicroButton:EnableMouse("true");
	SpellbookMicroButton:EnableMouse("true");
	TalentMicroButton:EnableMouse("true");
	AchievementMicroButton:EnableMouse("true");
	QuestLogMicroButton:EnableMouse("true");
	GuildMicroButton:EnableMouse("true");
	PVPMicroButton:EnableMouse("true");
	LFDMicroButton:EnableMouse("true");
	CompanionsMicroButton:EnableMouse("true");
	EJMicroButton:EnableMouse("true");
	MainMenuMicroButton:EnableMouse("true");
	HelpMicroButton:EnableMouse("true");
	Semi_LinkMicroMenuToDragButton();
end

function HideSemiMenu()
	CharacterMicroButton:SetAlpha(0);
	SpellbookMicroButton:SetAlpha(0);
	TalentMicroButton:SetAlpha(0);
	AchievementMicroButton:SetAlpha(0);
	QuestLogMicroButton:SetAlpha(0);
	GuildMicroButton:SetAlpha(0);
	PVPMicroButton:SetAlpha(0);
	LFDMicroButton:SetAlpha(0);
	CompanionsMicroButton:SetAlpha(0);
	EJMicroButton:SetAlpha(0);
	MainMenuMicroButton:SetAlpha(0);
	HelpMicroButton:SetAlpha(0);
	
	CharacterMicroButton:EnableMouse("false");
	SpellbookMicroButton:EnableMouse("false");
	TalentMicroButton:EnableMouse("false");
	AchievementMicroButton:EnableMouse("false");
	QuestLogMicroButton:EnableMouse("false");
	GuildMicroButton:EnableMouse("false");
	PVPMicroButton:EnableMouse("false");
	LFDMicroButton:EnableMouse("false");
	CompanionsMicroButton:EnableMouse("false");
	EJMicroButton:EnableMouse("false");
	MainMenuMicroButton:EnableMouse("false");
	HelpMicroButton:EnableMouse("false");
	
end


function SemiActionBars_OnEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 = ...;
   	if (event=="ADDON_LOADED" and arg1=="Semi_Action_Bars") or event=="PLAYER_ENTERING_WORLD" or event=="PLAYER_LOGIN" then
		SemiMainMenuBarDragButton:Hide();
		SemiOverrideActionBarDragButton:Hide();
		SemiBottomLeftBarDragButton:Hide();
		SemiBottomRightBarDragButton:Hide();
		SemiMicroMenuDragButton:Hide();
		SemiInventoryBagsDragButton:Hide();
		
		if (SF_MicroMenu_State) then
			ShowSemiMenu();
		elseif (not SF_MicroMenu_State) then
				HideSemiMenu();
		end
		if (SF_Bags_State) then
			ShowSemiBags();
		elseif (not SF_Bags_State) then
			HideSemiBags();
		end
		SetMenuBarScale(Semi_AllBars_Scale);
		Semi_LinkMicroMenuToDragButton();
		Semi_LinkInventoryBagsToDragButton();
		Semi_UpdateBarPositions();
	end
	
   	if (event=="UPDATE_BONUS_ACTIONBAR" or event=="ACTIONBAR_PAGE_CHANGED") and (not InCombatLockdown()) then
		Semi_UpdateBarPositions();
	end
	
	if (event=="UNIT_ENTERING_VEHICLE") and (not InCombatLockdown()) and (arg1=="player") and (arg2 == true) then   --
		Semi_UpdateVehicleBarPositions(arg5);
		--print("|cf0f0fff0Calling UpdateVehicleBarPositions - arg5 is: ", arg5);

	end
--[[
	if (event=="UNIT_ENTERING_VEHICLE") then
			--debug code
			print("|cffffccff--ENTERING - Vehicle");
			print("arg1 is: ", arg1);
			print("arg2 is: ", arg2);
			print("arg3 is: ", arg3);
			print("arg4 is: ", arg4);
			print("arg5 is: ", arg5);
			print("arg6 is: ", arg6);
			print("arg7 is: ", arg7);
			print("arg8 is: ", arg8);
			print("|cffffccff--ENTERING - dOnE");
	end
--	
	if (event=="UNIT_ENTERED_VEHICLE") then
		--Debug Code
			print("|cff00ccff--ENTERED - Vehicle");
			print("arg1 is: ", arg1);
			print("arg2 is: ", arg2);
			print("arg3 is: ", arg3);
			print("arg4 is: ", arg4);
			print("arg5 is: ", arg5);
			print("arg6 is: ", arg6);
			print("arg7 is: ", arg7);
			print("arg8 is: ", arg8);
			print("|cff00ccff--ENTERED - dOnE");

	end
--]]	
	if (event=="UNIT_EXITING_VEHICLE") and (not InCombatLockdown()) then
		if (arg1=="player") and ((arg2==false) or (arg2==nil)) then
			Semi_UpdateBarPositions();
			
		end
	end
--[[
	if (event=="UNIT_EXITING_VEHICLE") then
		--Debug Code
			print("|cff00ccffI'm EXITING  Vehicle");
			print("arg1 is: ", arg1);
			print("arg2 is: ", arg2);
			print("arg3 is: ", arg3);
			print("arg4 is: ", arg4);
			print("arg5 is: ", arg5);
			print("arg6 is: ", arg6);
			print("arg7 is: ", arg7);
			print("arg8 is: ", arg8);
			print("|cff00ccffEXITING DoNe.");
	end
--]]	
	if (event== "UNIT_EXITED_VEHICLE") and (not InCombatLockdown()) and (arg1=="player") then
		Semi_UpdateBarPositions();
		Semi_Show_Multi_Action_Bars_In_Use();
	end
--[[
	if (event=="UNIT_EXITED_VEHICLE") then
	--Debugg Code
		print("|cff00cc00EXITED  Vehicle");
		print("arg1 is: ", arg1);
		print("arg2 is: ", arg2);
		print("arg3 is: ", arg3);
		print("arg4 is: ", arg4);
		print("arg5 is: ", arg5);
		print("arg6 is: ", arg6);
		print("arg7 is: ", arg7);
		print("arg8 is: ", arg8);
		print("|cff00cc00EXITED DONE.");
	end
--]]
	if (event=="PLAYER_TALENT_UPDATE") and (not InCombatLockdown()) then
		if (arg1=="player") and ((arg2==false) or (arg2==nil)) then
			Semi_UpdateBarPositions();
		end
		if (arg1=="player") and (arg2==true) then
			Semi_UpdateVehicleBarPositions(arg5);
		end
	end
	if (event=="PLAYER_REGEN_ENABLED") then
		if (arg1=="player") and (arg2==true) then  --in a vehicle with a UI when leaving combat
			Semi_UpdateVehicleBarPositions(arg5);	-- this could be issue with the "balance panda" quest
		else
			Semi_UpdateBarPositions(); --not in a vehicle when leaving combat
		end
	end
	if (event=="CINEMATIC_STOP") and (not InCombatLockdown()) then
		if (arg1=="player") and (arg2==true) then
			Semi_UpdateVehicleBarPositions(arg5);
		else
			Semi_UpdateBarPositions();
		end
	end
	if (event=="PET_BATTLE_OPENING_START") then
		Semi_Hide_Multi_Action_Bars_In_Use();
	end
	if (event=="PET_BATTLE_CLOSE") then
		Semi_Show_Multi_Action_Bars_In_Use();
		Semi_UpdateBarPositions();
	end
end


function SetMenuBarScale(scale)
	MainMenuBar:SetScale(scale);
	MultiBarRight:SetScale(scale);
	MultiBarLeft:SetScale(scale);
end

local frame = CreateFrame("Frame", "Semi_MyAddOnFrame");
frame:SetScript("OnEvent", SemiActionBars_OnEvent);
frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("PLAYER_LOGIN");
frame:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
frame:RegisterEvent("UNIT_ENTERED_VEHICLE");
frame:RegisterEvent("UNIT_ENTERING_VEHICLE");
frame:RegisterEvent("UNIT_EXITING_VEHICLE");
frame:RegisterEvent("UNIT_EXITED_VEHICLE");
frame:RegisterEvent("PLAYER_REGEN_ENABLED");
frame:RegisterEvent("PLAYER_REGEN_DISABLED");
frame:RegisterEvent("UNIT_PET");
frame:RegisterEvent("PLAYER_TALENT_UPDATE");
frame:RegisterEvent("CINEMATIC_STOP");
frame:RegisterEvent("PET_BATTLE_OPENING_START");
frame:RegisterEvent("PET_BATTLE_CLOSE");

function Semi_UpdateBarPositions()
							--this double checks micro menu(i.e. not in vehicle) and gets to anchoring everything
	if (not InCombatLockdown()) and ((CharacterMicroButton:GetParent():GetName()) == "MainMenuBarArtFrame") then 
		if (SF_MicroMenu_State) then 
			ShowSemiMenu();
		elseif (not SF_MicroMenu_State) then
			HideSemiMenu();
		end
		if (SF_Bags_State) then 
			ShowSemiBags();
		elseif (not SF_Bags_State) then
			HideSemiBags();
		end
		Semi_LinkMainMenuBarToDragButton();
		Semi_LinkBottomLeftBarToDragButton();  --bottom left and right have their positions un-managed 
		Semi_LinkBottomRightBarToDragButton(); --so do we even need this anymore?
		
		Semi_LinkMicroMenuToDragButton();  --here we are moving the micro menu back where it belongs after combat
		Semi_LinkInventoryBagsToDragButton();
		Semi_MainMenuBarGridChoice();
	end
	-- adding check for temp variable that will be true if micro menu got moved while in combat, yet moved back to
	-- mainmenubarartframe while still in combat and never got the chance to get anchored back to my drag button
	
	if (not InCombatLockdown()) and (SemiMicroMoved) then
		Semi_LinkMicroMenuToDragButton();
		--I swear we are gonna anchor that damm thing down, even if it drives me insane.
	end
		
end

function Semi_Hide_Multi_Action_Bars_In_Use()
	if (not InCombatLockdown()) then
		if (Semi_AB_BL_State) then
			Semi_BottomLeft_Bar:Hide();
		end
		if (Semi_AB_BR_State) then
			Semi_BottomRight_Bar:Hide();
		end
	end
end

function Semi_Show_Multi_Action_Bars_In_Use()
	if (not InCombatLockdown()) then
		if (Semi_AB_BL_State) then
			Semi_BottomLeft_Bar:Show();
		end
		if (Semi_AB_BR_State) then
			Semi_BottomRight_Bar:Show();
		end
	end
end

function Semi_UpdateVehicleBarPositions(arg5)
	if (not InCombatLockdown()) then
		Semi_LinkOverrideActionBarToDragButton();
		OverrideActionBar:SetScale(Semi_VehicleBar_Scale);
		for i=1,12 do
			SemiMicroMenuButtons[i]:SetScale(1);
		end
		if (arg5 == true) then
			Semi_Hide_Multi_Action_Bars_In_Use();
		end
		if (not SF_XP_Bar_State) then
			OverrideActionBarExpBar:SetAlpha(0);
			OverrideActionBarExpBar:EnableMouse("false");
			OverrideActionBarExpBar:Hide();
		elseif (SF_XP_Bar_State) then
			OverrideActionBarExpBar:SetAlpha(1);
			OverrideActionBarExpBar:EnableMouse("true");
			OverrideActionBarExpBar:Show();
		end
		if (arg5 == false) or (arg5 == nil) or (arg5 == "") then
			--link micro menu to drag button
			Semi_LinkMicroMenuToDragButton();
		end
	end
end

	function Semi_MainMenuBarGridChoice()
	  if (not InCombatLockdown()) then
		if (SF_MainMenuBarGrid_State) then
			for i= 1, 12 do
				local gridbutton;
				gridbutton = getglobal("ActionButton"..i);
				gridbutton:SetAttribute("showgrid", 1);
				ActionButton_ShowGrid(gridbutton);
			end
		end
		if (not SF_MainMenuBarGrid_State) then
			for i= 1, 12 do
				local gridbutton;
				gridbutton = getglobal("ActionButton"..i);
				gridbutton:SetAttribute("showgrid", 0);
				ActionButton_HideGrid(gridbutton);
			end
		end
	  end
	end

-- Hiding the actionbar paging number - the Buttons are controlled by Semi_Core
MainMenuBarPageNumber:Hide();

-- Hiding various textures
MainMenuBarTexture2:Hide();
MainMenuBarTexture3:Hide();
MainMenuMaxLevelBar2:Hide();
MainMenuMaxLevelBar3:Hide();
ReputationWatchBarTexture2:SetTexture("");
ReputationWatchBarTexture3:SetTexture("");
ReputationXPBarTexture2:SetTexture("");
ReputationXPBarTexture3:SetTexture("");
SlidingActionBarTexture0:Hide();
SlidingActionBarTexture1:Hide();
StanceBarLeft:Hide();
StanceBarMiddle:Hide();
StanceBarRight:Hide();



